Subject: Re: 24.5; Font fallback doesn't work for the Emoji range

From: Eli Zaretskii <[email-masked]>
Date: Sat, 13 Jun 2015 10:04:32 +0300

> Date: Fri, 12 Jun 2015 13:57:26 -0700
> From: Paul Eggert <[email-masked]>
> CC: Eli Zaretskii <[email-masked]>, 
>  Vasilij Schneidermann <[email-masked]>,
>  Andy Moreton <[email-masked]>
> 
> The recent change to fontsel.el messed up my display when I was trying 
> to test obsolescent 8-bit environments.  I can reproduce the problem on 
> Fedora 21 x86-64 by running:
> 
> src/emacs -Q -font 
> -misc-fixed-medium-r-semicondensed--0-0-75-75-c-0-iso8859-1
> 
> and then by typing:
> 
> abc C-x 8 [ def C-x 8 ] ghi
> 
> This inserts "abc‘def’ghi" into *scratch*.  The display looks like "abc  
> ‘def’  ghi" with huge spaces around the quotes (see attached 
> screenshot).  There are similar problems with many other characters.  
> Apparently this is because I don't have the Symbola font installed, so 
> the change caused Emacs to fall back on Chinese double-width quotes 
> rather than on the font it used before (which is -misc-liberation 
> serif-medium-r-normal--13-94-100-100-p-74-iso10646-1 for the above 
> invocation of Emacs).

I recommend to either install Symbola (preferred) or customize the
default fontset on your system to use the font it used previously, if
you like it better than Symbola.

> I imagine that there will be similar problems with choosing Symbola even 
> if it's available, as users may prefer the font they've selected 
> explicitly

With the current master (even before your change), Symbola is
preferred only for punctuation and other symbols, and only if the
default font doesn't support those characters.  I don't expect users
to prefer some specific font for those, except their default font.
User preferences are expected in Unicode ranges that belong to users'
scripts, not for symbols and punctuation that their default font
doesn't already support.  In the rare cases where users do prefer
specific fonts for those characters, they can customize the fontsets.

> so perhaps the change should be enabled only for characters 
> that are not already available in the user-selected font?

That's what the code already does.  Are you saying that your default
font supported those quotes, and yet Emacs didn't use that font for
them?  You say above "fall back", and mention a non-default font,
which I understand to mean your default font didn't support those
characters.